//+------------------------------------------------------------------+
//|                                              ResourceBinTest.mq5 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"


#resource "ResourceBinTest.bin" as uchar ExtData[];


#ifndef    _Error_
   #define _Error_(info)  Print("Error: ",info," in line: "+(string)__LINE__+" file: "+__FILE__+" function: "+__FUNCTION__+" GetLastError: "+(string)GetLastError())
#endif

#ifndef    _ErrorDefault_
   #define _ErrorDefault_(info,r) {_Error_(info); r;}
#endif


#define _BytesArrSize_ 1024*1024 //1MB

uchar _BytesArr[_BytesArrSize_];


//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
{
   if (!CreatBinFile()) _ErrorDefault_("", return);
   if (!CheckExtData()) _ErrorDefault_("", return);
     
   Print("The end!");
}
//+------------------------------------------------------------------+


bool CreatBinFile()
{
   srand(0);
   
   ArrayInitialize(_BytesArr, 0);
   
   for (int i=0; i<_BytesArrSize_; ++i) _BytesArr[i] = uchar(rand() % 256);
   
   ResetLastError();
   
   if (!FileSave("ResourceBinTest.bin", _BytesArr)) _ErrorDefault_("", return false);

   return true;
}

bool CheckExtData()
{
   ResetLastError();
   
   if (ArrayCopy(_BytesArr, ExtData) != _BytesArrSize_) _ErrorDefault_("", return false);
   
   Print("ResourceArraySize(ExtData): ",ArraySize(ExtData));
   
   return true;
}